// BKTools.cpp:      .
//

#include "pch.h"
#include "BKTools.h"
#include "BKPack.h"
#include "BKCrun.h"

#include <clocale>
#include <io.h>
#include <sys/stat.h>

#include "getopt.h"

#pragma warning(disable:4996)

//  
std::wstring g_strInFileName;    //   
std::wstring g_strOutFileName;   //   
bool g_bRaw = false;        // ,     RAW 
bool g_bUnpack = false;     // ,  
int g_nWorkArea = -1;       //      . (-1 -  ,  )

FILE *g_File = nullptr;     // 
int g_nFileLen = 0, g_nFileAddress = 01000; //    
int g_nFileLoadAddress = 0; //     

BKTools g_tool = UNDEFINE;  //   

MemoryModel MMemory;


void Usage()
{
	wprintf(L"  BKTools  -0010(01) -0011()\n" \
	        L"() 2017-2021 gid\n\n" \
	        L":\n" \
	        L"BKTools -? (--help)\n" \
	        L"    .\n\n" \
	        L"BKTools -t<name> [-d][-l][-r][-u][-w<0addr>] <input_file_name> [output_file_name]\n" \
	        L"  -t<name> (--tool name) -   .\n" \
	        L"      name: BKPACK - / BKpack.\n" \
	        L"            BKCRUNCH - / Cruncher.\n\n" \
	        L"  -d (--data) -   ,   .\n" \
	        L"         .\n\n" \
	        L"  -l (--long) -   .\n" \
	        L"        -  .  ,    \n" \
	        L"      - ,   .\n\n" \
	        L"  -r (--raw) -   ,    '.bin'.\n\n" \
	        L"  -u (--unpack) -   .\n\n" \
	        L"  -w<0addr> (--work 0addr) -    .   \n" \
	        L"      BKPack.  ,     ,  040000,\n" \
	        L"       ,       .\n\n" \
	        L"  input_file_name -  .\n" \
	        L"  output_file_name -    ,   \n" \
	        L"           .\n" \
	        L"   ,        '.bkp'\n" \
	        L"  (  '.bkfile'  )  ,    .\n");
}

//     
//   ,    MMemory   0.
bool OpenInFile()
{
	bool bRet = false;
	uint16_t mBinHeader[2];
	struct _stat fi;

	if (0 == _wstat(g_strInFileName.c_str(), &fi))
	{
		if (fi.st_size < 0160000)
		{
			if ((g_File = _wfopen(g_strInFileName.c_str(), L"rb")) == nullptr)
			{
				wprintf(L"::     '%s'.\n", g_strInFileName.c_str());
			}
			else
			{
				//  ,   , .bin   ,
				//      
				int nOffset = 0;
				g_nFileLen = fi.st_size;

				if (sizeof(mBinHeader) == fread(mBinHeader, 1, sizeof(mBinHeader), g_File))
				{
					if (mBinHeader[1] == fi.st_size - 4)
					{
						nOffset = 4;
					}
					else if (mBinHeader[1] == fi.st_size - 22)
					{
						nOffset = 20;
					}

					if (nOffset) //   
					{
						g_nFileAddress = mBinHeader[0];  //    
						g_nFileLen = mBinHeader[1];
					}

					if (0 != fseek(g_File, nOffset, SEEK_SET))
					{
						wprintf(L"::     '%s'.\n", g_strInFileName.c_str());
					}
					else
					{
						//    
						// g_nFileLoadAddress = g_nFileAddress; //    
						if (g_nFileLen == fread(&MMemory.b[g_nFileLoadAddress], 1, g_nFileLen, g_File))
						{
							fclose(g_File);

							if (g_bUnpack)
							{
								wprintf(L" '%s' :: ", g_strInFileName.c_str());
							}
							else
							{
								wprintf(L" '%s' :: ", g_strInFileName.c_str());
							}

							bRet = true;
						}
						else
						{
							wprintf(L"::     '%s'.\n", g_strInFileName.c_str());
						}
					}
				}
				else
				{
					wprintf(L"::     '%s'.\n", g_strInFileName.c_str());
				}
			}
		}
		else
		{
			wprintf(L"::   .\n");
		}
	}
	else
	{
		wprintf(L"::   .\n");
	}

	return bRet;
}

//    BKPacka 
//  MMemory
bool SaveOutFileBKPack()
{
	bool bRet = false;
	uint16_t mBinHeader[2];

	if ((g_File = _wfopen(g_strOutFileName.c_str(), L"wb")) == nullptr)
	{
		wprintf(L"::       '%s'.\n", g_strOutFileName.c_str());
	}
	else
	{
		//   .bin
		mBinHeader[0] = g_nFileAddress;
		mBinHeader[1] = g_bUnpack ? BKPkParam.nFileLen : BKPkParam.EPK;

		if (!g_bRaw)
		{
			fwrite(mBinHeader, 1, sizeof(mBinHeader), g_File);
		}

		fwrite(&MMemory.b[g_nFileLoadAddress], 1, mBinHeader[1], g_File);
		fclose(g_File);
		bRet = true;
	}

	return bRet;
}
//    BKCrunch 
//  CrunMemory
bool SaveOutFileCrunch()
{
	bool bRet = false;
	uint16_t mBinHeader[2];

	if ((g_File = _wfopen(g_strOutFileName.c_str(), L"wb")) == nullptr)
	{
		wprintf(L"::       '%s'.\n", g_strOutFileName.c_str());
	}
	else
	{
		//   .bin
		mBinHeader[0] = g_nFileAddress;
		mBinHeader[1] = g_nFileLen;

		if (!g_bRaw)
		{
			fwrite(mBinHeader, 1, sizeof(mBinHeader), g_File);
		}

		fwrite(&CrunMemory.b[0], 1, mBinHeader[1], g_File);
		fclose(g_File);
		bRet = true;
	}

	return bRet;
}
//    
void getOutName(int argc, wchar_t **argv, std::wstring &ext)
{
	if (argc >= 1)
	{
		g_strOutFileName = (*argv) ? std::wstring(*argv) : L"out";
	}
	else
	{
		g_strOutFileName = g_strInFileName;
	}

	//    
	size_t pos = g_strOutFileName.rfind(L'.');

	if (pos == std::wstring::npos)
	{
		g_strOutFileName += ext;
	}
	else
	{
		g_strOutFileName = g_strOutFileName.substr(0, pos) + ext;
	}
}

int wmain(int argc, wchar_t *argv[], wchar_t *envp[])
{
	_wsetlocale(LC_ALL, L"Russian");
	static struct option long_options[] =
	{
		{ L"help",         ARG_NONE, nullptr, L'?' },
		{ L"tool",         ARG_REQ,  nullptr, L't' },
		{ L"raw",          ARG_NONE, nullptr, L'r' },
		{ L"unpack",       ARG_NONE, nullptr, L'u' },
		{ L"data",         ARG_NONE, nullptr, L'd' },
		{ L"long",         ARG_NONE, nullptr, L'l' },
		{ L"work",         ARG_REQ,  nullptr, L'w' },
		{ nullptr,         ARG_NULL, nullptr, ARG_NULL }
	};
	static wchar_t optstring[] = L"?t:rudlw:";
	int option_index = 0;
	int c;
	memset(&BKPkParam, 0, sizeof(BKPkParam));

	while ((c = getopt_long(argc, argv, optstring, long_options, &option_index)) != -1)
	{
		// Handle options
		c = tolower(c);

		switch (c)
		{
			case L'?':
				Usage();
				return 0;

			case L't':
				if (optarg)
				{
					std::wstring tool = std::wstring(optarg);

					for (wchar_t &i : tool)
					{
						i = toupper(i);
					}

					if (tool == L"BKPACK")
					{
						g_tool = BKPACK;
					}
					else if (tool == L"BKCRUNCH")
					{
						g_tool = BKCRUNCH;
					}
					else
					{
						Usage();
						return 0;
					}
				}
				else
				{
					Usage();
					return 0;
				}

				break;

			case L'd':
				BKPkParam.bData = true;
				break;

			case L'l':
				BKPkParam.bLongUnpacker = true;
				break;

			case L'r':
				g_bRaw = true;
				break;

			case L'u':
				g_bUnpack = true;
				break;

			case L'w':
			{
				int nTmp = _tcstol(optarg, nullptr, 8) & 0xffff;

				if (0 <= nTmp && nTmp <= 0140000)
				{
					g_nWorkArea = nTmp;
				}
			}
		}
	}

	argc -= optind;
	argv += optind;

	if (argc < 1)
	{
		wprintf(L"   :     .\n\n");
		Usage();
	}
	else
	{
		g_strInFileName = std::wstring(*argv);
		argc--;
		argv++;

		switch (g_tool)
		{
			case BKPACK:
			{
				getOutName(argc, argv, g_bUnpack ? std::wstring(L".bkfile") : std::wstring(L".bkp"));

				if (OpenInFile())
				{
					if (g_bUnpack)
					{
						if (BKUnPacking(g_nFileLoadAddress, g_nFileLen, g_nFileAddress))
						{
							SaveOutFileBKPack();
						}
					}
					else
					{
						if (BKPacking(0, g_nFileLen, g_nFileAddress))
						{
							SaveOutFileBKPack();
						}
					}
				}
			}
			break;

			case BKCRUNCH:
			{
				getOutName(argc, argv, g_bUnpack ? std::wstring(L".bkfile") : std::wstring(L".crn"));

				if (OpenInFile())
				{
					if (g_bUnpack)
					{
						CrunUnPack(0, g_nFileLen, g_nFileAddress);
						SaveOutFileCrunch();
					}
					else
					{
						CrunPack(0, g_nFileLen, g_nFileAddress);
						SaveOutFileCrunch();
					}
				}
			}
			break;

			default:
				wprintf(L"   .\n");
				Usage();
				break;
		}
	}

	return 0;
}

