#include "pch.h"
#include "ErrorManager.h"
#include "Globals.h"
#include "Listing.h"

#pragma warning(disable:4996)

BKTurboAsm_Error errors[] =
{
	{ ERROR_100 + 100, L"   ." },
	{ ERROR_101 + 100, L" .LA     ." },
	{ ERROR_102 + 100, L"       SOB." },
	{ ERROR_103 + 100, L"   ." },
	{ ERROR_104 + 100, L" ." },
	{ ERROR_105 + 100, L"    ." },
	{ ERROR_106 + 100, L" ." },
	{ ERROR_107 + 100, L"  ." },
	{ ERROR_108 + 100, L"   \'." },
	{ ERROR_109 + 100, L"     \"." },
	{ ERROR_110 + 100, L"     ." },
	{ ERROR_111 + 100, L"   ." },
	{ ERROR_112 + 100, L"  MARK." },
	{ ERROR_113 + 100, L"   ." },
	{ ERROR_114 + 100, L"  ." },
	{ ERROR_115 + 100, L"  ." },
	{ ERROR_116 + 100, L"   ." },
	{ ERROR_117 + 100, L" .BLKB  ." },
	{ ERROR_118 + 100, L" .BLKW  ." },
	{ ERROR_119 + 100, L" .ORG  ." },
	{ ERROR_120 + 100, L"  ." },
	{ ERROR_121 + 100, L" .END" },
	{ ERROR_122 + 100, L"    ." },
	{ ERROR_123 + 100, L"    ." },
	{ ERROR_124 + 100, L"    SOB." },
	{ ERROR_125 + 100, L"  TRAP." },
	{ ERROR_126 + 100, L"  EMT." },
	{ ERROR_127 + 100, L"    ." },
	{ ERROR_128 + 100, L"  ." },
	{ ERROR_129 + 100, L"  ." },
	{ ERROR_130 + 100, L"   ." },
	{ ERROR_131 + 100, L"     ." },
	{ ERROR_132 + 100, L"   include." },
	{ ERROR_133 + 100, L"   ." },
	{ ERROR_134 + 100, L"  ." },
	{ ERROR_135 + 100, L"   ." },
};

int IsError()
{
	return g_GlobalParameters.nError;
}

/*
   .
n -  
boutstr true -  ,    ,
*/
wchar_t errbuf[65536] = { 0 };
wchar_t errbuf2[65536] = { 0 };
void OutError(ERROR_NUMBER n, bool bOutStr, int nAddr)
{
	FILE *errf = _wfopen(L"_errors.txt", L"a");
	/*
	    :
	nAddr    ,      
	  .
	   nAddr == -1 ==   .
	           
	nAddr -   ,    110

	!!!       ,   .

	*/
	auto pll = g_Listing.end() - 1;

	if (nAddr == -1)
	{
		nAddr = g_GlobalParameters.nPC;
	}
	else if (n == ERROR_110)
	{
		//   ,        
		bool bEx = false;

		for (auto ll = g_Listing.begin(); ll != g_Listing.end(); ++ll)
		{
			for (auto &lct : ll->vCMD)
			{
				if (lct.nPC == nAddr && lct.LT == ListType::LT_INSTRUCTION)
				{
					pll = ll;
					bEx = true;
					break;
				}
			}

			if (bEx)
			{
				break;
			}
		}
	}

	//   .         110   .
	_swprintf(errbuf2, L"Error %3d: %s\n", errors[n].num, errors[n].str.c_str());
	_swprintf(errbuf, L"Line %d (Addr: %07o)", pll->nLineNum, CorrectAddress(nAddr));
	pll->errors.emplace_back(std::wstring(errbuf2)); //    
	wprintf(L"%s - %s", errbuf, errbuf2);

	if (errf)
	{
		fwprintf(errf, L"%s :: %s - %s", g_pReader->GetFileName().c_str(), errbuf, errbuf2);
	}

#if (DEBUG_LABEL_MANAGER)
	// /-----------------------debug---------------------------
	fwprintf(dbgF, L"%s", errbuf);
	// /-----------------------debug---------------------------
#endif

	//   -    ,  
	if (bOutStr)
	{
		wprintf(L"%s\n", pll->line.c_str());

		if (errf)
		{
			fwprintf(errf, L"%s\n", pll->line.c_str());
		}

#if (DEBUG_LABEL_MANAGER)
		// /-----------------------debug---------------------------
		fwprintf(dbgF, L"%s\n", pll->line.c_str());
		// /-----------------------debug---------------------------
#endif
	}

	if (errf)
	{
		fclose(errf);
	}

	g_GlobalParameters.nError++;
}

