#include "pch.h"
#include "Globals.h"

GlobalParams g_GlobalParameters;

UMemory g_Memory;

CReader *g_pReader = nullptr; //   
std::vector <CReader *> v_Reader; // ,   
CReader::FILE_CHARSET Charset = CReader::FILE_CHARSET::UNDEFINE;

void InitGlobalParameters(GlobalParams *gp)
{
	gp->bVerbosity = false;
	gp->bInString  = false;         // ,     ""  ascii, asciz  rad50
	gp->bOperandType = false;       // ,  . 0 = dd, !0 = ss,  OPssdd
	gp->bENDReached = false;        // ,    .end
	gp->bStopOnError = false;       //       
	gp->bLinkerFirst = true;        //    
	gp->nModeLinkage = 0;           //   : -1 = CL, 1 = CO, 0 =    .end
	gp->nAriphmType = 0;            //   ,   : -1 = , 1 - word   , 0 -  
	gp->nStartAddress = START_ADDRESS_OFFSET;     //       START_ADDRESS, 0 == -
	gp->nPC = BASE_ADDRESS;         //  PC  
	gp->nProgramLength = 0;         //   
	gp->nError = 0;
	gp->bStepInclude = false;
	gp->bInvert = false;
	memset(&(g_Memory.b), 0, 65536);
}
// .  .
void ReInitGlobalParameters(GlobalParams *gp)
{
	gp->bInString = false;          // ,     ""  ascii, asciz  rad50
	gp->bOperandType = false;       // ,  . 0 = dd, !0 = ss,  OPssdd
	gp->bENDReached = false;        // ,    .end
	gp->bStopOnError = false;       //       
	gp->bLinkerFirst = true;        //    
	gp->nModeLinkage = 0;           //   : -1 = CL, 1 = CO, 0 =    .end
	gp->nAriphmType = 0;            //   ,   : -1 = , 1 - word   , 0 -  
	gp->nPC = BASE_ADDRESS;         //  PC  
	gp->nProgramLength = 0;         //   
	gp->nError = 0;
	gp->bInvert = false;
	memset(&(g_Memory.b), 0, 65536);
}

void SetStartAddress(int addr)
{
	g_GlobalParameters.nStartAddress = addr;
}
int GetStartAddress()
{
	return g_GlobalParameters.nStartAddress & 0xffff;
}

int CorrectAddress(int addr)
{
	return (addr - BASE_ADDRESS + g_GlobalParameters.nStartAddress) & 0xffff;
}
int CorrectOffset(int addr)
{
	return (addr - BASE_ADDRESS - g_GlobalParameters.nStartAddress) & 0xffff;
}
