#include "pch.h"
#include "LabelManager.h"

CLabelTableRefs g_labelRefs;    //    ,   .
CLabelTable g_labelGlobalDefs;  //   
CLabelTable g_labelLocalDefs;   //   ,           
#pragma warning(disable:4996)

#if (DEBUG_LABEL_MANAGER)
// /-----------------------debug---------------------------
FILE *dbgF = nullptr;
void DebugInit()
{
	dbgF = _wfopen(L"debug_lbl.log", L"wt");
}
// /-----------------------debug---------------------------
#endif
/*
     
*/
bool AddLocalLabel(CBKToken *token, int value, uint32_t lt)
{
	bool bRet = g_labelLocalDefs.AddLabel(token, value, lt);
#if (DEBUG_LABEL_MANAGER)

	// /-----------------------debug---------------------------
	if (bRet)
	{
		fwprintf(dbgF, L"\nAdd Local %06o: '%s'\t(%d)\n", value, token->getName().c_str(), g_labelLocalDefs.getSize());
	}
	else
	{
		fwprintf(dbgF, L"\n!Add Local %06o: '%s'\t (%d) Already defined.\n", value, token->getName().c_str(), g_labelLocalDefs.getSize());
	}

	// /-----------------------debug---------------------------
#endif
	return bRet;
}

/*
     
*/
bool AddGlobalLabel(CBKToken *token, int value, uint32_t lt)
{
	bool bRet = false;

	if (bRet = g_labelGlobalDefs.AddLabel(token, value, lt))
	{
		g_labelLocalDefs.Clear();
	}

#if (DEBUG_LABEL_MANAGER)

	// /-----------------------debug---------------------------
	if (bRet)
	{
		fwprintf(dbgF, L"\nAdd Global %06o: '%s'\t(%d)\n", value, token->getName().c_str(), g_labelGlobalDefs.getSize());
		fwprintf(dbgF, L"Clear Local defs. (%d)\n", g_labelLocalDefs.getSize());
	}
	else
	{
		fwprintf(dbgF, L"\n!Add Global %06o: '%s'\t(%d) Already defined.\n", value, token->getName().c_str(), g_labelGlobalDefs.getSize());
		fwprintf(dbgF, L"!Not Clear Local defs. (%d)\n", g_labelLocalDefs.getSize());
	}

	// /-----------------------debug---------------------------
#endif
	return bRet;
}

/*
      
*/
bool AddlLabelReference(CBKToken *token, int value, uint32_t lt)
{
	bool bRet = g_labelRefs.AddLabel(token, value, lt);
#if (DEBUG_LABEL_MANAGER)

	// /-----------------------debug---------------------------
	if (bRet)
	{
		fwprintf(dbgF, L"\nAdd reference %06o: '%s' (%d)\n", value, token->getName().c_str(), g_labelRefs.getSize());
	}
	else
	{
		fwprintf(dbgF, L"\nReferences. Unknown error.\n");
	}

	// /-----------------------debug---------------------------
#endif
	return bRet;
}

bool SearchLabelInTables(CBKToken *token, int &value, uint32_t &lt)
{
	value = 0;
#if (DEBUG_LABEL_MANAGER)
	// /-----------------------debug---------------------------
	fwprintf(dbgF, L"\tSearch label: '%s'\n", token->getName().c_str());
	// /-----------------------debug---------------------------
#endif
	int n = g_labelLocalDefs.SearchLabel(token);

	if (n >= 0)
	{
		value = g_labelLocalDefs.GetValue(n);
		lt = g_labelLocalDefs.GetType(n);
#if (DEBUG_LABEL_MANAGER)
		// /-----------------------debug---------------------------
		fwprintf(dbgF, L"\tFound in Local Table: %06o\n", value);
		// /-----------------------debug---------------------------
#endif
	}
	else
	{
		n = g_labelGlobalDefs.SearchLabel(token);

		if (n >= 0)
		{
			value = g_labelGlobalDefs.GetValue(n);
			lt = g_labelGlobalDefs.GetType(n);
#if (DEBUG_LABEL_MANAGER)
			// /-----------------------debug---------------------------
			fwprintf(dbgF, L"\tFound in Global Table: %06o\n", value);
			// /-----------------------debug---------------------------
#endif
		}
	}

#if (DEBUG_LABEL_MANAGER)

	// /-----------------------debug---------------------------
	if (n < 0)
	{
		fwprintf(dbgF, L"\tLabel not found.\n");
	}

	// /-----------------------debug---------------------------
#endif
	return (n >= 0);
}
