#pragma once
#include "BKToken.h"

//  .
#define LABEL_DEFINITE_MASK     0x0000000F  //     
#define UNKNOWN_LABEL           0x00000000  //    
#define DEFINITE_LABEL          0x00000001  //     
#define CONSTANT_LABEL          0x00000002  //   ()
//    
#define LABEL_REFERENCE_MASK    0x000000F0  //     
#define BRANCH_LABEL            0x00000010  //   
#define RELATIVE_LABEL          0x00000020  //   
#define OFFSET_LABEL            0x00000030  //   
#define CURRENTPC_LABEL         0x00000040  //  ,   '.'   PC
//  
#define HALFLABEL_FLAG          0x00000100  //   
#define NEGATIVE_FLAG           0x00000200  //  
#define INVERSE_FLAG            0x00000400  //  

using Label = struct LBL
{
	uint32_t    label_type;
	int         label_value;
	CBKToken    label;

	LBL() = default;
	LBL(uint32_t lt, int lv, CBKToken *pt)
		: label_type(lt)
		, label_value(lv)
		, label(*pt) {}
};

//     .
//   - , ,  ,    .
class CLabelTable
{
	protected:
		std::vector <Label> LabelTable;

	public:
		CLabelTable();
		virtual ~CLabelTable();

		void               Clear();    //   
		inline size_t      getSize()
		{
			return LabelTable.size();
		}

		virtual bool        AddLabel(CBKToken *token, int value, uint32_t lt);
		virtual CBKToken   *GetLabel(size_t n);
		virtual void        DeleteLabel(CBKToken *token);
		virtual void        DeleteLabel(size_t n);
		virtual int         SearchLabel(CBKToken *token);
		virtual int         GetValue(CBKToken *token);
		virtual int         GetValue(size_t n);
		virtual uint32_t    GetType(CBKToken *token);
		virtual uint32_t    GetType(size_t n);
};

//    .   -      
//       .
class CLabelTableRefs : public CLabelTable
{
	public:
		CLabelTableRefs();
		virtual ~CLabelTableRefs() override;
		virtual bool        AddLabel(CBKToken *token, int value, uint32_t lt) override;
};

