#pragma once

enum class ListType : int
{
	LT_BLANKLINE,
	LT_COMMENTARY,  // 
	LT_ASSIGN,      // 
	LT_LABEL,       // 
	LT_INSTRUCTION, //   
	LT_PSC_ADDR,    //  ADDR
	LT_PSC_LA,      //  LA
	LT_PSC_PRINT,   //  PRINT
	LT_PSC_BLKW,    //  BLKW
	LT_PSC_BLKB,    //  BKLB
	LT_PSC_WORD,    //  WORD
	LT_PSC_BYTE,    //  BYTE
	LT_PSC_END,     //  END
	LT_PSC_EVEN,    //  EVEN
	LT_PSC_RAD50,   //  RAD50
	LT_PSC_ASCII,   //  ASCII,ASCIIZ
	LT_PSC_FLT2,    //  FLT2
	LT_PSC_FLT4,    //  FLT4
};

struct ListingCmdType
{
	int nPC;        //      
	int nEndAdr;    //      
	ListType LT;    //    
};


struct ListingLine
{
	int nLineNum;           //  
	std::wstring line;           //  
	std::vector<std::wstring> errors; //  .
	std::vector <ListingCmdType> vCMD;

	ListingLine() : nLineNum(0)
	{}
};

extern std::vector <ListingLine> g_Listing;

void Lst_PrepareLine(int cp);
void Lst_AddPrepareLine(int cp, ListType lt);
void Lst_AddPrepareLine2(int len);
void MakeListing(const std::wstring &strName, const std::wstring &strExt);
/*
    2 
1.       ,   .

2.        , 
,        
         .

*/
