#pragma once
#include "LabelManager.h"

enum class OBJTags : uint32_t
{
	OBJ_HDRTAG = 0x5501,
	OBJ_ID,             //   
	OBJ_DATA,           //   
	OBJ_GLB,            //    
	OBJ_LOC,            //    
	OBJ_REF,            //     
	OBJ_Label
};

constexpr auto OBJVERSION = 0x1001;

struct OBJBlockHeader
{
	OBJTags  nHdrTag;
	OBJTags  nBlockTag;
	uint32_t nBlkLen;
	uint32_t nEntryCount;
	uint32_t nCheckSum;
};

struct OBJIDBlock
{
	uint32_t nVersion;
	int16_t nStartAddress;
	int16_t nMode;
};

bool MakeObj(const std::wstring &strName, const std::wstring &strExt, bool bTbl = false);
bool LoadObj(const std::wstring &strName);
bool findBlock(OBJBlockHeader &hdr, OBJTags tag);
bool OBJ_SaveIDBlk();
bool OBJ_ReadIDBlk(OBJIDBlock &data);
bool OBJ_SaveLabelTable(CLabelTable *lbltbl, OBJTags nTag);
bool OBJ_LoadLabelTable(CLabelTable *lbltbl, OBJBlockHeader &hdr);
bool OBJ_SaveData();
bool OBJ_ReadData(uint32_t nLen);

/*
 .
  .
  :
1.   
2.    ( )
3.    .
4.  
*/


